<template>
	<mind-layout>
		<mind-form v-model="recurso" @submit="onSubmit">
			<template v-slot="{form}">
					<el-row  >
						<el-col :lg="12">
							<el-form-item label="Nombre">
								<el-input v-model="form.nombre" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col :lg="12">
							<el-form-item label="% Comision">
								<el-slider
									v-model="form.comision"
									:step="10" show-input
									show-stops>
								</el-slider>
							</el-form-item>
						</el-col>
					</el-row>
					<el-divider content-position="left">Gastos a Cargo de la Agencia</el-divider>
					<el-row  >
						<el-col :lg="12">
							<el-form-item label="% Combustible">
								<el-slider
									v-model="form.combustibleAgencia"
									:step="10" show-input
									show-stops>
								</el-slider>
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="% Gastos">
								<el-slider
									v-model="form.gastosAgencia"
									:step="10" show-input
									show-stops>
								</el-slider>
							</el-form-item>
						</el-col>
					</el-row>
			</template>
		</mind-form>
	</mind-layout>
</template>
<script>
import store from '@/store/comisiones'
import {Rest} from '@/../vendor/mind-core-web'

export default {
	async created(){
		this.api = new Rest({
			uri: `/api/viajes/agencias/${store.idAgencia}/comisiones`, 
			state: store.data,
			key: 'id'
		})

		let id = this.$route.params.id
		if(id == 'new') {
			this.isNew = true
			this.recurso = {	}
		} else {
			this.recurso = await this.api.Fetch(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});				
			})
		}
	},

	methods: {
		async onSubmit(data) {
			let result, msg ;
			if(this.isNew) {
				await this.api.Post(data)
				.then(()=>{
					result = 'success'
					msg = 'Comision creada correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			} else {
				await this.api.Patch(data)
				.then(()=>{
					result = 'success'
					msg = 'Comisión actualizada correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			}
			this.$message({
				type: result,
				showClose: true,
				message: msg
			});
		}
	},
	data() {
		return {
			isNew: false,
			recurso: {},
			api: null
		}
	}
}
</script>